#import "PIPController.h"
#import <OmniNetworking/OmniNetworking.h>

@implementation PIPController

- (void)getImageFromBlueBox:(id)sender
{
	// Get blue box ip from window
	NSString *hostName;
	unsigned short hostPort = 7;
        ONTCPSocket *tcpSocket;
        NSMutableData *spyData;
	NSImage	*spyImage;

          hostName = [blueBoxIP stringValue];

        if ( !hostName || [hostName isEqualToString:@""] ) 
	{
		[statusBox setStringValue:@"Can't connect to Blue Box, no address specified."];
 		return;
	}
	else {
		[statusBox setStringValue:@"Connecting to Blue Box."];
	}


	// open tcp socket to blue box, read data until connection closes

        tcpSocket = (ONTCPSocket *)[ONTCPSocket socket];
        [tcpSocket connectToHost:[ONHost hostForHostname:hostName] port:hostPort];
	spyData = [[NSMutableData alloc] init];

	[statusBox setStringValue:@"Receiving spy report."];
	while (YES) {
        	[statusBox setStringValue:@"."];
	
        	NS_DURING {
                    [spyData appendData:[tcpSocket readData]];
        	} NS_HANDLER {
            		// Probably disconnected
            		[statusBox setStringValue:@"Picture received."];
            		break;
        	} NS_ENDHANDLER;

    	}

 
// Create an NSImage from the data (it's JPEG)

        spyImage = [[NSImage alloc] initWithData:spyData];
	if ( spyImage != nil ) {
                [blueBoxImageView setImage:spyImage];
	}
        else {
            [statusBox setStringValue:@"Can't read spy report."];
        }
      
}

@end
